PROGRAM_NAME='MainProgram'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvTouchPanel = 10001:1:0

vdvPrayTimeNotifier = 33001:1:0


(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

char PARAMETERDESCRIPTIONLIST_TIMEFORMATS[][15] 		 = {'24-hour', 
								    '12-hour AM/PM', 
								    '12-hour', 
								    'Fraction'}

char PARAMETERDESCRIPTIONLIST_CALCULATIONMETHODS[][50] 		 = {'Jafari / Ithna Ashari',
								    'University of Islamic Sciences, Karachi',
								    'Islamic Society of North America (ISNA)',
								    'Muslim World League (MWL)',
								    'Umm Al-Qura, Makkah',
								    'Egyptian General Authority of Survey',
								    'Custom Setting',
								    'Institute of Geophysics, University of Tehran'}

char PARAMETERDESCRIPTIONLIST_JURISTICMETHODS[][20] 		 = {'Shafii (standard)',
								    'Hanafi'}

char PARAMETERDESCRIPTIONLIST_HIGHLATITUDEADJUSTIMENTMETHDS[][35]= {'No adjustment',
								    'Middle of night adjustment',
								    '1/7th of night adjustment',
								    'Angle/60th of night adjustment'}


char NAMELIST_PRAYNAMES[][15] 	 = {'Fajr Pray', 
				    'Sunrise', 
				    'Dhuhr Pray', 
				    'Asr Pray', 
				    'Sunset', 
				    'Maghrib Pray',
				    'Isha Pray'}

char NAMELIST_ADHANNAME[][20] 	 = {'Adhan Of Alaqsa',
				    'Adhan Of Egypt',
				    'Adhan Of Halab',
				    'Adhan Of Madina',
				    'Adhan Of Makkah',
				    'Ding Dong',
				    'None'}

char NAMELIST_ADHANFILENAME[][20]= {'AdhanAlaqsa.mp3',
				    'AdhanEgypt.mp3',
				    'AdhanHalab.mp3',
				    'AdhanMadina.mp3',
				    'AdhanMakkah.mp3',
				    'doorbell6.wav',
				    ''}



integer BTTN_LATITUDE 	= 11
integer BTTN_LONGITUDE 	= 12
integer BTTN_TIMEZONE	= 13

integer BTTNLIST_TIMEFORMAT[] = {21,22,23,24}
integer BTTNLIST_CALCULATIONMETHOD[] = {31,32,33,34,35,36,37,38}
integer BTTNLIST_JURISTICMETHOD[] = {41,42}
integer BTTNLIST_HIGHLATITUDEADJUSTMENTMETHOD[] = {51,52,53,54}
integer BTTNLIST_ADHAN[] = {61,62,63,64,65,66,67}
integer BTTNLIST_ADHANPREVIEW[] = {161,162,163,164,165,166}

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

integer keypadIsShownForButton = 0

double latitude, longitude
float timeZone
integer timeFormat
integer calculationMethod
integer JuristicMethod
integer highLatitudeAdjustmentMethod

integer selectedAdhanIndex = 1

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

// Time Format Selection Buttons 
([dvTouchPanel, 21]..[dvTouchPanel, 24])

// Calculation Method Selection Buttons 
([dvTouchPanel, 31]..[dvTouchPanel, 38])

// Juristic Method Selection Buttons 
([dvTouchPanel, 41]..[dvTouchPanel, 42])

// High Latitude Adjustment Method Selection Buttons 
([dvTouchPanel, 51]..[dvTouchPanel, 54])

// Adhan Sound File Selection Buttons 
([dvTouchPanel, 61]..[dvTouchPanel, 67])

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)



(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

//stringUnderTest = ldate

define_module 'PrayTimeNotifier' mod1(vdvPrayTimeNotifier)


(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

data_event[vdvPrayTimeNotifier]
{
    online:
    {
	send_string 0,'Module is Online'
	
	// I will now set the settings for dubai parameters 
	latitude = 25.2522
	longitude = 55.28
	timeZone = 4
	calculationMethod = 5
	
	// then I will send these settings to the module to calculate the pray times 
	send_command vdvPrayTimeNotifier, "'Coordinates-', ftoa(latitude),',', ftoa(longitude)"
	send_command vdvPrayTimeNotifier, "'TimeZone-', ftoa(timeZone)"
	send_command vdvPrayTimeNotifier, "'TimeFormat-', itoa(timeFormat)"
	send_command vdvPrayTimeNotifier, "'CalculationMethod-', itoa(calculationMethod)"
	send_command vdvPrayTimeNotifier, "'JuristicMethod-', itoa(JuristicMethod)"
	send_command vdvPrayTimeNotifier, "'HighLatitudesMethod-', itoa(highLatitudeAdjustmentMethod)"
	send_command vdvPrayTimeNotifier, "'ACTIVATE-THELICENSEKEY,THEACIVATIONKEY'"

	// I will now send the "REINIT" command to the module to calculate the pray times according to the sent parameters above 
	send_command vdvPrayTimeNotifier, "'REINIT'"
    }
    offline:
    {
	send_string 0,'Module is Offline'
    }
    string:
    {
	char buffer[100]
	char response[50]
	
	send_string 0,"'Received Response is: ', data.text"
	
	buffer = data.text
	
	response = remove_string(buffer, '-', 1)
	
	if(upper_string(response) == upper_string('Coordinates-'))
	{
	    latitude = atof(remove_string(buffer, ',', 1))
	    longitude = atof(buffer)
	    send_command dvTouchPanel, "'^TXT-11,0,', ftoa(latitude)"
	    send_command dvTouchPanel, "'^TXT-12,0,', ftoa(longitude)"
	}
	else if(upper_string(response) == upper_string('TimeZone-'))
	{
	    timeZone = atof(buffer)
	    send_command dvTouchPanel, "'^TXT-13,0,', buffer"
	}
	else if(upper_string(response) == upper_string('TimeFormat-'))
	{
	    timeFormat = atoi(buffer)
	    send_command dvTouchPanel, "'^TXT-20,0,', PARAMETERdESCRIPTIONLIST_TIMEFORMATS[timeFormat]"
	}
	else if(upper_string(response) == upper_string('CalculationMethod-'))
	{
	    calculationMethod = atoi(buffer)
	    send_command dvTouchPanel, "'^TXT-30,0,', PARAMETERdESCRIPTIONLIST_CALCULATIONMETHODS[calculationMethod]"
	}
	else if(upper_string(response) == upper_string('JuristicMethod-'))
	{
	    JuristicMethod = atoi(buffer)
	    send_command dvTouchPanel, "'^TXT-40,0,', PARAMETERdESCRIPTIONLIST_JURISTICMETHODS[JuristicMethod]"
	}
	else if(upper_string(response) == upper_string('HighLatitudesMethod-'))
	{
	    highLatitudeAdjustmentMethod = atoi(buffer)
	    send_command dvTouchPanel, "'^TXT-50,0,', PARAMETERdESCRIPTIONLIST_HIGHLATITUDEADJUSTIMENTMETHDS[highLatitudeAdjustmentMethod]"
	}
	else if(upper_string(response) == upper_string('PrayTimes-'))
	{
	    char prayTime[10]
	    
	    // now I will show the pray times and calculation settings popups, and hide the calculation in progress popup 
	    send_command dvTouchPanel, "'@PPN-SettingsPopup;MainPage'"
	    send_command dvTouchPanel, "'@PPN-PrayTimesTable;MainPage'"
	    send_command dvTouchPanel, "'@PPF-CalculationInProgress;MainPage'"

	    // I will now start extracting the pray times from the received string and loading them to the touch panel 
	    
	    // Fajr Time
	    prayTime = remove_string(buffer, ',', 1)				// extracting the pray time from the buffer 
	    set_length_string(prayTime, length_string(prayTime) - 1)		// this line to remove the extra comma at the end 
	    send_command dvTouchPanel, "'^TXT-1,0,', prayTime"				// sending the time to the touch panel 
	    
	    // Sunrise Time
	    prayTime = remove_string(buffer, ',', 1)				// extracting the pray time from the buffer 
	    set_length_string(prayTime, length_string(prayTime) - 1)		// this line to remove the extra comma at the end 
	    send_command dvTouchPanel, "'^TXT-2,0,', prayTime"				// sending the time to the touch panel 
	    
	    // Dhuhr Time
	    prayTime = remove_string(buffer, ',', 1)				// extracting the pray time from the buffer 
	    set_length_string(prayTime, length_string(prayTime) - 1)		// this line to remove the extra comma at the end 
	    send_command dvTouchPanel, "'^TXT-3,0,', prayTime"				// sending the time to the touch panel 
	    
	    // Asr Time
	    prayTime = remove_string(buffer, ',', 1)				// extracting the pray time from the buffer 
	    set_length_string(prayTime, length_string(prayTime) - 1)		// this line to remove the extra comma at the end 
	    send_command dvTouchPanel, "'^TXT-4,0,', prayTime"				// sending the time to the touch panel 
	    
	    // Sunset Time
	    prayTime = remove_string(buffer, ',', 1)				// extracting the pray time from the buffer 
	    set_length_string(prayTime, length_string(prayTime) - 1)		// this line to remove the extra comma at the end 
	    send_command dvTouchPanel, "'^TXT-5,0,', prayTime"				// sending the time to the touch panel 
	    
	    // Maghrib Time
	    prayTime = remove_string(buffer, ',', 1)				// extracting the pray time from the buffer 
	    set_length_string(prayTime, length_string(prayTime) - 1)		// this line to remove the extra comma at the end 
	    send_command dvTouchPanel, "'^TXT-6,0,', prayTime"				// sending the time to the touch panel 
	    
	    // Isha Time
	    send_command dvTouchPanel, "'^TXT-7,0,', buffer"				// sending the time to the touch panel 
	}
	else if(upper_string(response) == upper_string('Activated-'))
	{
	    // now I will show the module activation message in case the module is not activated
	    if(!find_string(upper_string(buffer), 'YES', 1))
	    {
		send_command dvTouchPanel, "'@PPN-ModuleActivationNotification;MainPage'"
		ON[dvTouchPanel, 99]
	    }
	    else 
	    {
		OFF[dvTouchPanel, 99]
	    }
	}
    }
}

data_event[dvTouchPanel]
{
    online:
    {
	// now I will get the calculation settings from the module 
	send_command vdvPrayTimeNotifier, '?Coordinates'
	send_command vdvPrayTimeNotifier, '?TimeZone'
	send_command vdvPrayTimeNotifier, '?TimeFormat'
	send_command vdvPrayTimeNotifier, '?CalculationMethod'
	send_command vdvPrayTimeNotifier, '?JuristicMethod'
	send_command vdvPrayTimeNotifier, '?HighLatitudesMethod'

	// now I will get the currently calculated pray times 
	send_command vdvPrayTimeNotifier, '?PrayTimes'
	
	// now I will show the proper popups on the toucn panel 
	send_command dvTouchPanel, "'@PPN-SettingsPopup;MainPage'"
	send_command dvTouchPanel, "'@PPN-PrayTimesTable;MainPage'"
	
	// I will now show the name of the selected Adhan 
	send_command dvTouchPanel, "'^TXT-60,0,', NAMELIST_ADHANNAME[selectedAdhanIndex]"
    }
    string:
    {
	char tpBuffer[50]
	
	tpBuffer = data.text

	send_string 0, "'Rx >>>>>>> ', data.text"
	
	if(find_string(data.text, 'KEYP', 1) > 0 && find_string(data.text, 'ABORT', 1) ==  0)
	{
	    remove_string(tpBuffer, '-', 1)

	    // now I will store the entered value to the proper variable 
	    // according to the tracking variable used to track which button is asctivating the keypad 
	    if(keypadIsShownForButton == BTTN_LATITUDE)
		latitude = atof(tpBuffer)
	    else if(keypadIsShownForButton == BTTN_LONGITUDE)
		longitude = atof(tpBuffer)
	    else if(keypadIsShownForButton == BTTN_TIMEZONE)
		timeZone = atof(tpBuffer)
		
	    // and I will send the value to the proper button on the touch panel 
	    send_command dvTouchPanel, "'^TXT-', itoa(keypadIsShownForButton),',0,', tpBuffer"
	    
	    // and finaly because one of the calculation parameter is changed, I will clear the current pray times from the touch panel 
	    send_command dvTouchPanel, "'^TXT-1.7,0,--:--'"
	}
    }
}

// because buttons for latitude, longitude and time zone all will show a keypad to enter the correct value 
// I will write a button event to trigger the keypad for all these buttons 
button_event[dvTouchPanel, 11]
button_event[dvTouchPanel, 12]
button_event[dvTouchPanel, 13]
{
    push:
    {
	char keypadPrompt[20]
	
	// I will not set the keypad prompt based on the pressed button 
	if(button.input.channel == 11)		keypadPrompt = 'Enter Latitude'
	else if(button.input.channel == 12)	keypadPrompt = 'Enter Longitude'
	else if(button.input.channel == 13)	keypadPrompt = 'Enter Time Zone +/-'
	
	// I will now show the extended keypad because floating point and/or - keys are required to enter these values 
	send_command dvTouchPanel, "'@EKP-;', keypadPrompt"
	
	// finally I will trace which button is causeing the keypad show 
	keypadIsShownForButton = button.input.channel
    }
}

button_event[dvTouchPanel, 20]
{
    push:
    {
	// I will now show the proper settings popup 
	send_command dvTouchPanel, "'@PPN-TimeFormatSelection;MainPage'"
	
	// now I will highlight the selected parameter 
	ON[dvTouchPanel, timeFormat + 20]
    }
}

button_event[dvTouchPanel, BTTNLIST_TIMEFORMAT]
{
    push:
    {
	// I will now hide the settings popup 
	send_command dvTouchPanel, "'@PPF-TimeFormatSelection;MainPage'"
	
	// then I will update the proper varaible and the touch panel with the selected value 
	timeFormat = get_last(BTTNLIST_TIMEFORMAT)
	send_command dvTouchPanel, "'^TXT-20,0,', PARAMETERdESCRIPTIONLIST_TIMEFORMATS[timeFormat]"
	
	// and finaly because one of the calculation parameter is changed, I will clear the current pray times from the touch panel 
	send_command dvTouchPanel, "'^TXT-1.7,0,--:--'"
    }
}

button_event[dvTouchPanel, 30]
{
    push:
    {
	// I will now show the proper settings popup 
	send_command dvTouchPanel, "'@PPN-CalcMethodSelection;MainPage'"

	// now I will highlight the selected parameter 
	ON[dvTouchPanel, calculationMethod + 30]
    }
}

button_event[dvTouchPanel, BTTNLIST_CALCULATIONMETHOD]
{
    push:
    {
	// I will now hide the settings popup 
	send_command dvTouchPanel, "'@PPF-CalcMethodSelection;MainPage'"

	// then I will update the proper varaible and the touch panel with the selected value 
	calculationMethod = get_last(BTTNLIST_CALCULATIONMETHOD)
	send_command dvTouchPanel, "'^TXT-30,0,', PARAMETERdESCRIPTIONLIST_CALCULATIONMETHODS[calculationMethod]"
	
	// and finaly because one of the calculation parameter is changed, I will clear the current pray times from the touch panel 
	send_command dvTouchPanel, "'^TXT-1.7,0,--:--'"
    }
}

button_event[dvTouchPanel, 40]
{
    push:
    {
	// I will now show the proper settings popup 
	send_command dvTouchPanel, "'@PPN-JuristicMethodSelection;MainPage'"

	// now I will highlight the selected parameter 
	ON[dvTouchPanel, JuristicMethod + 40]
    }
}

button_event[dvTouchPanel, BTTNLIST_JURISTICMETHOD]
{
    push:
    {
	// I will now hide the settings popup 
	send_command dvTouchPanel, "'@PPF-JuristicMethodSelection;MainPage'"

	// then I will update the proper varaible and the touch panel with the selected value 
	JuristicMethod = get_last(BTTNLIST_JURISTICMETHOD)
	send_command dvTouchPanel, "'^TXT-40,0,', PARAMETERdESCRIPTIONLIST_JURISTICMETHODS[JuristicMethod]"
	
	// and finaly because one of the calculation parameter is changed, I will clear the current pray times from the touch panel 
	send_command dvTouchPanel, "'^TXT-1.7,0,--:--'"
    }
}

button_event[dvTouchPanel, 50]
{
    push:
    {
	// I will now show the proper settings popup 
	send_command dvTouchPanel, "'@PPN-HighLatAdjMethodSelection;MainPage'"

	// now I will highlight the selected parameter 
	ON[dvTouchPanel, highLatitudeAdjustmentMethod + 50]
    }
}

button_event[dvTouchPanel, BTTNLIST_HIGHLATITUDEADJUSTMENTMETHOD]
{
    push:
    {
	// I will now hide the settings popup 
	send_command dvTouchPanel, "'@PPF-HighLatAdjMethodSelection;MainPage'"

	// then I will update the proper varaible and the touch panel with the selected value 
	highLatitudeAdjustmentMethod = get_last(BTTNLIST_HIGHLATITUDEADJUSTMENTMETHOD)
	send_command dvTouchPanel, "'^TXT-50,0,', PARAMETERdESCRIPTIONLIST_HIGHLATITUDEADJUSTIMENTMETHDS[highLatitudeAdjustmentMethod]"
	
	// and finaly because one of the calculation parameter is changed, I will clear the current pray times from the touch panel 
	send_command dvTouchPanel, "'^TXT-1.7,0,--:--'"
    }
}

button_event[dvTouchPanel, 60]
{
    push:
    {
	// I will now show the proper settings popup 
	send_command dvTouchPanel, "'@PPN-AdhanSelection;MainPage'"

	// now I will highlight the selected parameter 
	ON[dvTouchPanel, selectedAdhanIndex + 60]
    }
}

button_event[dvTouchPanel, BTTNLIST_ADHAN]
{
    push:
    {
	// I will now hide the settings popup 
	send_command dvTouchPanel, "'@PPF-AdhanSelection;MainPage'"

	// then I will update the proper varaible and the touch panel with the selected value 
	selectedAdhanIndex = get_last(BTTNLIST_ADHAN)
	send_command dvTouchPanel, "'^TXT-60,0,', NAMELIST_ADHANNAME[selectedAdhanIndex]"
    }
}

button_event[dvTouchPanel, BTTNLIST_ADHANPREVIEW]
{
    push:
    {
	[dvTouchPanel, button.input.channel] = ![dvTouchPanel, button.input.channel]
    }
}

button_event[dvTouchPanel, 100]
{
    push:
    {
	// I will now send the calculation parameters set on the touc panel to the module 
	send_command vdvPrayTimeNotifier, "'Coordinates-', ftoa(latitude),',', ftoa(longitude)"
	send_command vdvPrayTimeNotifier, "'TimeZone-', ftoa(timeZone)"
	send_command vdvPrayTimeNotifier, "'TimeFormat-', itoa(timeFormat)"
	send_command vdvPrayTimeNotifier, "'CalculationMethod-', itoa(calculationMethod)"
	send_command vdvPrayTimeNotifier, "'JuristicMethod-', itoa(JuristicMethod)"
	send_command vdvPrayTimeNotifier, "'HighLatitudesMethod-', itoa(highLatitudeAdjustmentMethod)"
	
	// I will now send the "REINIT" command to the module to calculate the pray times according to the sent parameters above 
	send_command vdvPrayTimeNotifier, "'REINIT'"
/*	
	// while waiting for the module to calculate the new pray times
	// I will clear the currently showing times from the touch panel to avoid any confusion 
	send_command dvTouchPanel, "'^TXT-1.7,0,--:--'"
*/
	// now I will hide the pray times and calculation settings popups, and show the calculation in progress popup 
	send_command dvTouchPanel, "'@PPF-SettingsPopup;MainPage'"
	send_command dvTouchPanel, "'@PPF-PrayTimesTable;MainPage'"
	send_command dvTouchPanel, "'@PPN-CalculationInProgress;MainPage'"
    }
}

button_event[dvTouchPanel, 200]
{
    push:
    {
	// now I will show the pray times and calculation settings popups, and hide the pray notification popup 
	send_command dvTouchPanel, "'@PPN-SettingsPopup;MainPage'"
	send_command dvTouchPanel, "'@PPN-PrayTimesTable;MainPage'"
	send_command dvTouchPanel, "'@PPF-PrayTimeNotification;MainPage'"
    }
}

channel_event[vdvPrayTimeNotifier, 1]
channel_event[vdvPrayTimeNotifier, 3]
channel_event[vdvPrayTimeNotifier, 4]
channel_event[vdvPrayTimeNotifier, 6]
channel_event[vdvPrayTimeNotifier, 7]
{
    ON:
    {
	// now I will set the correct time name on the notification popup 
	send_command dvTouchPanel, "'^TXT-70,0,', NAMELIST_PRAYNAMES[channel.channel]"
	
	// then I will hide the pray times and calculation settings popups, and show the pray notification popup 
	send_command dvTouchPanel, "'@PPF-SettingsPopup;MainPage'"
	send_command dvTouchPanel, "'@PPF-PrayTimesTable;MainPage'"
	send_command dvTouchPanel, "'@PPN-PrayTimeNotification;MainPage'"
	
	// then I will play the selected Adhan sound 
	send_command dvTouchPanel, "'@SOU-', NAMELIST_ADHANFILENAME[selectedAdhanIndex]"
    }
}

channel_event[vdvPrayTimeNotifier, 2]
channel_event[vdvPrayTimeNotifier, 5]
{
    ON:
    {
	// now I will set the correct time name on the notification popup 
	send_command dvTouchPanel, "'^TXT-70,0,', NAMELIST_PRAYNAMES[channel.channel]"
	
	// then I will hide the pray times and calculation settings popups, and show the pray notification popup 
	send_command dvTouchPanel, "'@PPF-SettingsPopup;MainPage'"
	send_command dvTouchPanel, "'@PPF-PrayTimesTable;MainPage'"
	send_command dvTouchPanel, "'@PPN-PrayTimeNotification;MainPage'"
	
	// then I will play the selected Adhan sound 
	send_command dvTouchPanel, "'@SOU-doorbell6.wav'"
    }
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM


(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
